//xsetaseta@gmail.com
//
//DS1077 con arduino 1.8.5
//12/06/2019

/*
  I2C SDA (data line) = analog pin 4
  I2C SDC (clock line) = analog pin 5
  Resistencias de 10K a Vcc
*/


#include <Wire.h>
 
#define DS1077_ADDRESS 0b1011000
 
// command sets
#define DIV 0x01 // operating frequency
#define MUX 0x02 // mode of operation
#define BUS 0x0D // bus settings
#define E2  0x3F // EEPROM

unsigned int rmux=0b0001111110000000; // 1MX=/1  tambien salida 0 
unsigned int tempDiv=1000;

float frecuencia;
float FreBase=66666666;
int M1=8;
int M0=8;

unsigned int nTemp;

//___________
char entrada[100];
int  trozos[10];
long  trozosVal[10];
int contador;
boolean stringComplete = false;
char * puntero;



void setup()
{
  Serial.begin(9600);
  Wire.begin(); // We're I2C-Bus Master
  delay(100);
  Serial.print("DS1077\n");  
  SetDiv();  delay(100);  SetMux();  
}

void loop()
{
  int z, i;

  while (Serial.available())
  {
    char inChar = (char)Serial.read();
    entrada[contador] = inChar;
    if (inChar == '\n')
    {
      stringComplete = true;
      entrada[contador] = 0;
    }
    contador++;
  }


  if (stringComplete)
  {
    Serial.println(entrada);
    for (z = 0; z < 10; z++)trozos[z] = 0;
    trozos[0] = 0;
    for (z = 0, i = 1; z < 100 && z < contador ; z++)
    {
      if (entrada[z] > 96 && entrada[z] < 123) entrada[z] -= 32; //mayusculas
      if (entrada[z] < 32) entrada[z] = 32;
      if (entrada[z] == ',' || entrada[z] == ' '|| entrada[z] == '.' )
      {
        entrada[z] = 0;
        trozos[i] = z + 1;
        trozosVal[i] = atol(entrada + trozos[i]);
        i++;
      }
    }

    for (z = 0; z < 10 ; z++)
    {
      if (trozos[z] == 0 && z != 0) break;
      puntero = entrada + trozos[z];
    }

    z = strlen(entrada);
    switch (z)
    { 
             
      case 4: 
        if (!strncmp(entrada, "FREC", 4))
        { 
          //Serial.print("->FREC ");   Serial.println(trozosVal[1]);
          if(FreBase/trozosVal[1]<1025)
            {
              tempDiv=(FreBase/trozosVal[1])-2;              
              bitClear(rmux,7);
              bitClear(rmux,8);
              M1=1;              
            }
            else
            {
                if((FreBase/2)/trozosVal[1]<1025)
                  {
                    tempDiv=((FreBase/2)/trozosVal[1])-2;
                    SetDiv();
                    bitSet(rmux,7);
                    bitClear(rmux,8);
                    M1=2;
                  }
                  else
                  {
                    if((FreBase/4)/trozosVal[1]<1025)
                      {
                        tempDiv=((FreBase/4)/trozosVal[1])-2;
                        SetDiv();
                        bitClear(rmux,7);
                        bitSet(rmux,8);
                        M1=4;
                      }
                      else
                      {
                        tempDiv=((FreBase/8)/trozosVal[1])-2;
                        SetDiv();
                        bitSet(rmux,7);
                        bitSet(rmux,8);
                        M1=8;
                        
                      }                   
                  }              
            }
          SetDiv();  delay(100);  SetMux();
          list();
                    
          goto salir0;
        }  
     
        if (!strncmp(entrada, "FREB", 4))
        {
          Serial.println("-> FREB ");
          FreBase=trozosVal[1];
          FreBase*=1000;
          list();
          goto salir0;
        }
        if (!strncmp(entrada, "HELP", 4))
        {
          Serial.println("_____HELP_____");
          Serial.println("FREB  [Frecuencia Base KHz]  Default=66666");
          Serial.println("FREC  [Frecuencia]");
          Serial.println("LIST");
          goto salir0;
        }
        break;
      case 6:
        if (!strncmp(entrada, "DS1077", 6))
        {
          Serial.println("OK");
          goto salir0;
        }
        break;
     
    }
error0:
    Serial.print("ERROR ");  Serial.println(entrada);
salir0:
    Serial.println("______________");
    contador = 0;
    stringComplete = false;
    for (z = 0; z < 100 ; z++)entrada[z] = 0;
  }

}


void list(void)
{
          Serial.print("FreBase=");Serial.println(long(FreBase));
          Serial.print("FrecuenciaTeorica=");Serial.println(long(frecuencia));
          SetDiv();  delay(100);  SetMux();
}

void SetMux(void)
{
  ds1077_write(MUX, highByte(rmux), lowByte(rmux));   
  //Serial.print("MUX ");   Serial.println(rmux,BIN); 
}

void SetDiv(void)
{
 unsigned int n;
    
    n=tempDiv;
    n=n<<6;
    setRdiv(n);
    frecuencia=(FreBase/M1)/(tempDiv+2);
  
  //Serial.print("Divisor=");Serial.println((tempDiv+2)*M1);
  //Serial.print("FrecuenciaTeorica=");Serial.println(frecuencia);
}
//_______________________________________________________
 
void setRdiv(unsigned int n) 
{
    ds1077_write(DIV, highByte(n), lowByte(n));
}
 
void ds1077_write(int command, byte msb, byte lsb) 
{
    Wire.beginTransmission(DS1077_ADDRESS);
    Wire.write(command); 
    // MSB then LSB
    Wire.write(msb);
    Wire.write(lsb);
    Wire.endTransmission();
}





