//xsetaseta@gmail.com
//
//DS1077 con arduino 1.8.5
//12/06/2019

/*
  I2C SDA (data line) = analog pin 4
  I2C SDC (clock line) = analog pin 5
  Resistencias de 10K a Vcc
*/


#include <Wire.h>
 
#define DS1077_ADDRESS 0b1011000
 
// command sets
#define DIV 0x01 // operating frequency
#define MUX 0x02 // mode of operation
#define BUS 0x0D // bus settings
#define E2  0x3F // EEPROM

unsigned int rmux=0b0001111110000000; // 1MX=/1  tambien salida 0 
unsigned int tempDiv=1000;

float frecuencia;
float FreBase=66666666;
int M1=8;
int M0=8;

unsigned int nTemp;

//___________
char entrada[100];
int  trozos[10];
long  trozosVal[10];
int contador;
boolean stringComplete = false;
char * puntero;



void setup()
{
  Serial.begin(9600);
  Wire.begin(); // We're I2C-Bus Master

  delay(100);
  Serial.println("DS1077");  
  SetDiv();  delay(100);  SetMux();
}

void loop()
{
  int z, i;

  while (Serial.available())
  {
    char inChar = (char)Serial.read();
    entrada[contador] = inChar;
    if (inChar == '\n')
    {
      stringComplete = true;
      entrada[contador] = 0;
    }
    contador++;
  }


  if (stringComplete)
  {
    Serial.println(entrada);
    for (z = 0; z < 10; z++)trozos[z] = 0;
    trozos[0] = 0;
    for (z = 0, i = 1; z < 100 && z < contador ; z++)
    {
      if (entrada[z] > 96 && entrada[z] < 123) entrada[z] -= 32; //mayusculas
      if (entrada[z] < 32) entrada[z] = 32;
      if (entrada[z] == ',' || entrada[z] == ' '|| entrada[z] == '.' )
      {
        entrada[z] = 0;
        trozos[i] = z + 1;
        trozosVal[i] = atol(entrada + trozos[i]);
        i++;
      }
    }

    for (z = 0; z < 10 ; z++)
    {
      if (trozos[z] == 0 && z != 0) break;
      puntero = entrada + trozos[z];
    }

    z = strlen(entrada);
    switch (z)
    { 
             
      case 4: 
        if (!strncmp(entrada, "FREC", 4))
        { 
          //Serial.print("->FREC ");   Serial.println(trozosVal[1]);
          if(FreBase/trozosVal[1]<1025)
            {
              tempDiv=(FreBase/trozosVal[1])-2;              
              bitClear(rmux,7);
              bitClear(rmux,8);
              M1=1;              
            }
            else
            {
                if((FreBase/2)/trozosVal[1]<1025)
                  {
                    tempDiv=((FreBase/2)/trozosVal[1])-2;
                    SetDiv();
                    bitSet(rmux,7);
                    bitClear(rmux,8);
                    M1=2;
                  }
                  else
                  {
                    if((FreBase/4)/trozosVal[1]<1025)
                      {
                        tempDiv=((FreBase/4)/trozosVal[1])-2;
                        SetDiv();
                        bitClear(rmux,7);
                        bitSet(rmux,8);
                        M1=4;
                      }
                      else
                      {
                        tempDiv=((FreBase/8)/trozosVal[1])-2;
                        SetDiv();
                        bitSet(rmux,7);
                        bitSet(rmux,8);
                        M1=8;
                        
                      }                   
                  }              
            }
          SetDiv();  delay(100);  SetMux();
          list();
                    
          goto salir0;
        }  

        if (!strncmp(entrada, "DIVX", 4))
        { 
          Serial.print("->DIVX ");   Serial.println(trozosVal[1]);
          tempDiv=trozosVal[1];
          SetDiv();          
          goto salir0;
        }  
        
        if (!strncmp(entrada, "MX1M", 4))
        { 
          Serial.print("->MX1M ");   Serial.println(trozosVal[1]);
          if( bitRead(trozosVal[1],0) )
            bitSet(rmux,7);
           else
            bitClear(rmux,7);
            
          if( bitRead(trozosVal[1],1) )
            bitSet(rmux,8);
           else
            bitClear(rmux,8);

          switch (trozosVal[1])
            { 
              case 0:
              M1=1; break;
              case 1:
              M1=2; break;
              case 2:
              M1=4; break;
              case 3:
              M1=8; break;
            }
          SetMux(); 
          goto salir0;
        }  

        if (!strncmp(entrada, "MX0M", 4))
        { 
          Serial.print("->MX0M ");   Serial.println(trozosVal[1]);
          if( bitRead(trozosVal[1],0) )
            bitSet(rmux,9);
           else
            bitClear(rmux,9);
            
          if( bitRead(trozosVal[1],1) )
            bitSet(rmux,10);
           else
            bitClear(rmux,10);

          switch (trozosVal[1])
            { 
              case 0:
              M0=1; break;
              case 1:
              M0=2; break;
              case 2:
              M0=4; break;
              case 3:
              M0=8; break;
            }
          SetMux();  
          goto salir0;
        }  

        if (!strncmp(entrada, "MDIV", 4))
        { 
          Serial.print("->MDIV ");   Serial.println(trozosVal[1]);
          if( bitRead(trozosVal[1],0) )
            bitSet(rmux,6);
           else
            bitClear(rmux,6); 
          SetMux(); 
          goto salir0;
        }           
        if (!strncmp(entrada, "RDIV", 4))
        {
          Serial.print("->RDIV ");   Serial.println(trozosVal[1]);
          setRdiv(trozosVal[1]);
          goto salir0;
        }
        if (!strncmp(entrada, "RMUX", 4))
        {
          Serial.print("->RMUX ");    Serial.println(trozosVal[1]);
          nTemp=trozosVal[1];
          ds1077_write(MUX, highByte(nTemp), lowByte(nTemp));
          goto salir0;
        }
        if (!strncmp(entrada, "RBUS", 4))
        {
          Serial.print("->RBUS ");   Serial.println(trozosVal[1]);
          nTemp=trozosVal[1];
          ds1077_write(BUS, highByte(nTemp), lowByte(nTemp));
          goto salir0;
        }
        if (!strncmp(entrada, "RWRI", 4))
        {
          Serial.print("->RWRI ");   Serial.println(trozosVal[1]);
          nTemp=trozosVal[1];
          ds1077_write(E2, highByte(nTemp), lowByte(nTemp));
          goto salir0;
        }
        if (!strncmp(entrada, "LIST", 4))
        {
          Serial.println("->LIST ");
          list();
          goto salir0;
        }
        if (!strncmp(entrada, "FREB", 4))
        {
          Serial.println("-> FREB ");
          FreBase=trozosVal[1];
          FreBase*=1000;
          list();
          goto salir0;
        }
        if (!strncmp(entrada, "HELP", 4))
        {
          Serial.println("_____HELP_____");
          Serial.println("MDIV  [0-1]     Activar prescaler [0=enable, 1=disable]");
          Serial.println("DIVX  [0-1023]  Divider     dividir[2-1025]");
          Serial.println("    00000000 00000000 /2");
          Serial.println("    00000000 00000001 /3");
          Serial.println("    00000000 00000010 /4");
          Serial.println("    00000000 00000011 /5");
          Serial.println("MX0M  [0-3] Prescaler 0   div[1,2,4,8]");
          Serial.println("MX1M  [0-3] Prescaler 1   div[1,2,4,8]");
          Serial.println("FREB  [Frecuencia KHz]  Default=66666");
          Serial.println("FREC  [Frecuencia]");
          Serial.println("LIST");
          Serial.println("REGISTROS -> RDIV,RMUX,RBUS,RWRI [0-65536]");
          goto salir0;
        }
        break;
      case 6:
        if (!strncmp(entrada, "DS1077", 6))
        {
          Serial.println("OK");
          goto salir0;
        }
        break;
     
    }
error0:
    Serial.print("ERROR ");  Serial.println(entrada);
salir0:
    Serial.println("______________");
    contador = 0;
    stringComplete = false;
    for (z = 0; z < 100 ; z++)entrada[z] = 0;
  }

}


void list(void)
{
          Serial.print("FreBase=");Serial.println(long(FreBase));
          Serial.print("DivM0="); Serial.println(M0);
          Serial.print("DivM1="); Serial.println(M1);
          Serial.print("DIV="); Serial.println(tempDiv);
          Serial.print("MUX="); Serial.println(rmux,BIN);
          Serial.print("Divisor=");Serial.println((tempDiv+2)*M1);
          Serial.print("FrecuenciaTeorica=");Serial.println(long(frecuencia));
          SetDiv();  delay(100);  SetMux();
}

void SetMux(void)
{
  ds1077_write(MUX, highByte(rmux), lowByte(rmux));   
  //Serial.print("MUX ");   Serial.println(rmux,BIN); 
}

void SetDiv(void)
{
 unsigned int n;
    
    n=tempDiv;
    n=n<<6;
    setRdiv(n);
    frecuencia=(FreBase/M1)/(tempDiv+2);
  
  //Serial.print("Divisor=");Serial.println((tempDiv+2)*M1);
  //Serial.print("FrecuenciaTeorica=");Serial.println(frecuencia);
}
//_______________________________________________________
 
void setRdiv(unsigned int n) 
{
    ds1077_write(DIV, highByte(n), lowByte(n));
}
 
void ds1077_write(int command, byte msb, byte lsb) 
{
    Wire.beginTransmission(DS1077_ADDRESS);
    Wire.write(command); 
    // MSB then LSB
    Wire.write(msb);
    Wire.write(lsb);
    Wire.endTransmission();
}





